# allq_rest

Allq - the Ruby gem for the AllQ

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build allq_rest.gemspec
```

Then either install the gem locally:

```shell
gem install ./allq_rest-1.0.0.gem
```
(for development, run `gem install --dev ./allq_rest-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'allq_rest', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/YOUR_GIT_USERNAME/YOUR_GIT_REPO, then add the following in the Gemfile:

    gem 'allq_rest', :git => 'https://github.com/YOUR_GIT_USERNAME/YOUR_GIT_REPO.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'allq_rest'

api_instance = Allq::ActionsApi.new

job_id = "job_id_example" # String | Job ID


begin
  #Bury
  result = api_instance.bury_put(job_id)
  p result
rescue Allq::ApiError => e
  puts "Exception when calling ActionsApi->bury_put: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8090*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Allq::ActionsApi* | [**bury_put**](docs/ActionsApi.md#bury_put) | **PUT** /bury | Bury
*Allq::ActionsApi* | [**job_delete**](docs/ActionsApi.md#job_delete) | **DELETE** /job | Delete
*Allq::ActionsApi* | [**job_get**](docs/ActionsApi.md#job_get) | **GET** /job | Job
*Allq::ActionsApi* | [**job_post**](docs/ActionsApi.md#job_post) | **POST** /job | Job
*Allq::ActionsApi* | [**parent_job_post**](docs/ActionsApi.md#parent_job_post) | **POST** /parent_job | Parent  Job
*Allq::ActionsApi* | [**peek_get**](docs/ActionsApi.md#peek_get) | **GET** /peek | Peek
*Allq::ActionsApi* | [**release_put**](docs/ActionsApi.md#release_put) | **PUT** /release | Release
*Allq::ActionsApi* | [**set_children_started_put**](docs/ActionsApi.md#set_children_started_put) | **PUT** /set_children_started | Set Children Started
*Allq::ActionsApi* | [**throttle_post**](docs/ActionsApi.md#throttle_post) | **POST** /throttle | Throttle
*Allq::ActionsApi* | [**touch_put**](docs/ActionsApi.md#touch_put) | **PUT** /touch | Touch
*Allq::ActionsApi* | [**tube_delete**](docs/ActionsApi.md#tube_delete) | **DELETE** /tube | Clear Tube
*Allq::AdminApi* | [**stats_get**](docs/AdminApi.md#stats_get) | **GET** /stats | Stats
*Allq::AdminApi* | [**update_servers_put**](docs/AdminApi.md#update_servers_put) | **PUT** /update_servers | Reset Server Urls


## Documentation for Models

 - [Allq::BasicPayload](docs/BasicPayload.md)
 - [Allq::BasicResponse](docs/BasicResponse.md)
 - [Allq::JobRef](docs/JobRef.md)
 - [Allq::JobResponse](docs/JobResponse.md)
 - [Allq::NewJob](docs/NewJob.md)
 - [Allq::NewParentJob](docs/NewParentJob.md)
 - [Allq::StatsInfo](docs/StatsInfo.md)
 - [Allq::StatsResults](docs/StatsResults.md)
 - [Allq::StatsTube](docs/StatsTube.md)
 - [Allq::Throttle](docs/Throttle.md)
 - [Allq::TubeRef](docs/TubeRef.md)


## Documentation for Authorization

 All endpoints do not require authorization.

